program_name='HDanywhere_HD_Matrix_Demo'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 23/10/2012  AT: 13:35           *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: First release$
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)

#include 'HDanywhere_HD_Matrix_Constants.axi'

define_device 
dvTP          	 = 10002:1:1

vdvModule44      = 33001:1:1
vdvModule88      = 33002:1:1
vdvModule44_v2   = 33003:1:1

dvHKM44	         = 5001:3:1
dvHKM88	         = 5001:2:1
dvHKM44_v2       = 5001:1:1

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
define_constant
CMD_OUTPUT_1                              = 1
CMD_OUTPUT_2                              = 2
CMD_OUTPUT_3                              = 3
CMD_OUTPUT_4                              = 4
CMD_OUTPUT_5                              = 5
CMD_OUTPUT_6                              = 6
CMD_OUTPUT_7                              = 7
CMD_OUTPUT_8                              = 8


CMD_INPUT_1                              = 21
CMD_INPUT_2                              = 22
CMD_INPUT_3                              = 23
CMD_INPUT_4                              = 24
CMD_INPUT_5                              = 25
CMD_INPUT_6                              = 26
CMD_INPUT_7                              = 27
CMD_INPUT_8                              = 28


CMD_MODEL_HKM44							 = 52
CMD_MODEL_HKM88							 = 53
CMD_MODEL_HKM44_v2						 = 54

NUMBER_OF_BUTTONS	         			 = 8

CMD_SEND								 = 60 

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)

define_variable

constant integer iMODEL_HKM44 = MODEL_HKM44
constant integer iMODEL_HKHA414SW = MODEL_HKHA414SW
constant integer iMODEL_HKHA414SW_V2 = MODEL_HKHA414SW_V2
constant integer iMODEL_HKM88 = MODEL_HKM88

constant integer OUTPUT_NUMBERS[] = 
{
  CMD_OUTPUT_1,   
  CMD_OUTPUT_2,   
  CMD_OUTPUT_3,   
  CMD_OUTPUT_4,
  CMD_OUTPUT_5,               
  CMD_OUTPUT_6,   
  CMD_OUTPUT_7,  
  CMD_OUTPUT_8
  
};

constant integer INPUT_NUMBERS[] = 
{
  CMD_INPUT_1,   
  CMD_INPUT_2,   
  CMD_INPUT_3,   
  CMD_INPUT_4,
  CMD_INPUT_5,               
  CMD_INPUT_6,   
  CMD_INPUT_7,  
  CMD_INPUT_8
  
};


Constant Integer HKM_MODEL_NUMBERS[] = 
{
  CMD_MODEL_HKM44,	
  CMD_MODEL_HKM88,
  CMD_MODEL_HKM44_v2
};

Constant dev VIRTUAL_DEVICE[] = 
{
  vdvModule44,
  vdvModule88,  
  vdvModule44_v2
};



char g_buffer[256];
char g_Version[25];
dev g_vdvCurrentModel;


define_module

define_module 'HDanywhere_HD_Matrix'  HKM_88(vdvModule88, dvHKM88, iMODEL_HKM88 );
define_module 'HDanywhere_HD_Matrix'  HKM_44(vdvModule44, dvHKM44, iMODEL_HKM44 );
define_module 'HDanywhere_HD_Matrix'  HKM_44_V2(vdvModule44_v2, dvHKM44_v2, iMODEL_HKHA414SW_V2 );


(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
define_event

data_event[dvTP]
{
  online:
  {
    send_command dvTP, "'^TXT-100,0,',g_Version";
    do_push( dvTP, CMD_MODEL_HKM88 );
  }
}

button_event[dvTP, OUTPUT_NUMBERS]
{
  push:
  {
    integer but;
  
    but = get_last( OUTPUT_NUMBERS );
    send_command dvTP, "'^BCF-',itoa( OUTPUT_NUMBERS[but] ),',1,#000748FF'";
    if (g_buffer != "")
      g_buffer = "g_buffer,',',itoa( but )";
    else 
      g_buffer = "itoa( but )";
  }
}

button_event[dvTP, INPUT_NUMBERS]
{
  push:
  {
    integer but;
    integer butTextFeedBack;
    integer count;
    char cJunk[3];
    
    but = get_last( INPUT_NUMBERS );
    send_command g_vdvCurrentModel,"'SW ',g_buffer,'=',itoa( but ),';' ";
    
    count = 1; 
    while (count != 0)
    {
      count  = find_string ( g_buffer, ',', 1 );	
      cJunk = remove_string( g_buffer, ',', 1 );
      cJunk = left_string( cJunk, (length_string( cJunk ) - 1) );
      if (cjunk == "")
        cJunk = g_buffer;
      send_command dvTP, "'^TXT-',cJunk,',0,',itoa( but )";
      send_command dvTP, "'^BCF-',cJunk,',1,#0216CDFF'";
    }
    g_buffer = "";
  }
}


button_event[dvTP, HKM_MODEL_NUMBERS]
{
  push:
  {
    integer count1;
    integer count2;
    integer but;
    integer inputAmount;
    integer outputAmount;
    
    but = get_last( HKM_MODEL_NUMBERS );
    for (count1 = 1; count1 <= NUMBER_OF_BUTTONS ; count1++)
    {
      send_command dvTP, "'^BCF-',itoa( INPUT_NUMBERS[count1] ),',1,#AEAEAEFF'";
      send_command dvTP, "'^ENA-',itoa( INPUT_NUMBERS[count1] ),',0'";
      send_command dvTP, "'^BCF-',itoa( OUTPUT_NUMBERS[count1] ),',1,#AEAEAEFF'";
      send_command dvTP, "'^ENA-',itoa( OUTPUT_NUMBERS[count1] ),',0'";
      send_command dvTP, "'^TXT-',itoa( OUTPUT_NUMBERS[count1] ),',0,',''";
      //send_command dvTP, "'^BCF-',itoa( HKM_MODEL_NUMBERS[count1] ),',1,#0216CDFF'";
    }
   
    switch (but)
    {
      case MODEL_HKM44:    
      {
	inputAmount = 4;
	outputAmount = 4;
	g_vdvCurrentModel = vdvModule44;
	wait (10);
	send_command dvTP, "'^BCF-',itoa( HKM_MODEL_NUMBERS[but] ),',1,#000748FF'";
	BREAK
      }
      case MODEL_HKM88:
      {
	inputAmount = 8;
	outputAmount = 8;
	g_vdvCurrentModel = vdvModule88;
	wait (10);
	send_command dvTP, "'^BCF-',itoa( HKM_MODEL_NUMBERS[but] ),',1,#000748FF'";
	BREAK
      }
      case MODEL_HKHA414SW_V2:
      {
	inputAmount = 4;
	outputAmount = 4;
	g_vdvCurrentModel = vdvModule44_v2;
	wait (10);
	send_command dvTP, "'^BCF-',itoa( HKM_MODEL_NUMBERS[but] ),',1,#000748FF'";
	BREAK
      }		
			
    }

    count1 = 0;
    for (count1 = 1; count1 <= inputAmount; count1++)
    {
      send_command dvTP, "'^BCF-',itoa( INPUT_NUMBERS[count1] ),',1,#6276FDFF'";
      send_command dvTP, "'^ENA-',itoa( INPUT_NUMBERS[count1] ),',1'";
    }
	
    count2 = 0;
    for (count2 = 1; count2 <= outputAmount; count2++)
    {
      send_command dvTP, "'^BCF-',itoa( OUTPUT_NUMBERS[count2] ),',1,#0216CDFF'";
      send_command dvTP, "'^ENA-',itoa( OUTPUT_NUMBERS[count2] ),',1'";
    }
    wait (10)
      send_command g_vdvCurrentModel,"'SW?'";
  }
}
  
data_event[VIRTUAL_DEVICE]
{
  string:
  {
    char cJunk[255], fbOutput[3], fbInput[3];
  
    if (find_string( data.text, 'SW ', 1 ))
    {
      while (data.text != "")
      {
        cJunk = remove_string( data.text, 'SW ', 1 );
        cJunk = remove_string( data.text, ';', 1 );
        fbOutput = remove_string( cJunk, '=', 1 );
        fbOutput = left_string( fbOutput, (length_string( fbOutput ) - 1) );
        fbInput = cJunk;
        fbInput = left_string( fbInput, (length_string( fbInput ) - 1) );
        if (fbInput != "" || fbOutput != "")
	  send_command dvTP, "'^TXT-',fbOutput,',0,',fbInput";
      }
    }
    if (find_string( data.text, 'Version', 1 ))
    {
      send_command dvTP, "'^TXT-100,0,',data.text";
      g_Version = data.text
    }
  }
}


(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
define_program


