PROGRAM_NAME='HDanywhere_HD_Matrix_Demo'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 27.04.13  AT: 13:00    		   *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* 				                                           *)
(***********************************************************)
(*
    Tested NI3100, HDanywhere 4x4 
	Programmer Janus Technology
*)

define_device

dvTP          	 = 10002:1:1

vdvHDAnywhere    = 33001:1:1

//dvHDAnywhere     = 0:4:0
dvHDAnywhere     = 5001:1:1

define_constant

CMD_OUTPUT_1                              = 1
CMD_OUTPUT_2                              = 2
CMD_OUTPUT_3                              = 3
CMD_OUTPUT_4                              = 4
CMD_OUTPUT_5                              = 5
CMD_OUTPUT_6                              = 6
CMD_OUTPUT_7                              = 7
CMD_OUTPUT_8                              = 8

CMD_INPUT_1                              = 21
CMD_INPUT_2                              = 22
CMD_INPUT_3                              = 23
CMD_INPUT_4                              = 24
CMD_INPUT_5                              = 25
CMD_INPUT_6                              = 26
CMD_INPUT_7                              = 27
CMD_INPUT_8                              = 28

FB_VERSION								 = 101

CMD_SEND								 = 60 
NUMBER_OF_BUTTONS	         			 = 8

define_variable

//Panel join Numbers 
constant integer cOUTPUT_NUMBERS[] = 
{
  CMD_OUTPUT_1,   
  CMD_OUTPUT_2,   
  CMD_OUTPUT_3,   
  CMD_OUTPUT_4,
  CMD_OUTPUT_5,               
  CMD_OUTPUT_6,   
  CMD_OUTPUT_7,  
  CMD_OUTPUT_8
};

constant integer cINPUT_NUMBERS[] = 
{
  CMD_INPUT_1,   
  CMD_INPUT_2,   
  CMD_INPUT_3,   
  CMD_INPUT_4,
  CMD_INPUT_5,               
  CMD_INPUT_6,   
  CMD_INPUT_7,  
  CMD_INPUT_8
};

char g_sOutputBuffer[256];
dev g_vdvCurrentModel;
char sHDAnywhereIP[15] = '172.16.106.90';

integer g_mode = 1 //1 = serl, 2 = udp, 3 = http
integer g_model = 1 // 1 = 4x4, 2 = 8x8

define_mutually_exclusive

define_module 'HDanywhere_HD_Matrix'  HKM_( vdvHDAnywhere, dvHDAnywhere, g_mode, g_model ,sHDAnywhereIP );

// When panel comes online we send the version to the panel
define_event

data_event[dvTP]
{
  online:
  {
	send_command vdvHDAnywhere, "'VERSION?'";
  }
}

// on selection of output, we store the output into a buffer until
// the input is selected, this is so multiable output and be process quickly
button_event[dvTP, cOUTPUT_NUMBERS]
{
  push:
  {
    integer but;
  
    but = get_last( cOUTPUT_NUMBERS );
	// change colour on keypad to show selection
    send_command dvTP, "'^BCF-',itoa( cOUTPUT_NUMBERS[but] ),',1,#000748FF'";
    // outputs are separated by ','s
	if (g_sOutputBuffer != "")
      g_sOutputBuffer = "g_sOutputBuffer,',',itoa( but )";
    else 
      g_sOutputBuffer = "itoa( but )";
  }
}

//On selection of input we send the input and the output buffer to the module
//set the panel back to the original colours
//set the feedback on panel, the module will correct it if the execution of the module does wrong
button_event[dvTP, cINPUT_NUMBERS]
{
  push:
  {
    integer iBut;
    integer iCount;
    char sOutput[3];
    
    iBut = get_last( cINPUT_NUMBERS );
    send_command vdvHDAnywhere, "'SW ',g_sOutputBuffer,'=',itoa( iBut ),';' ";
    iCount = 1; 
	// extracting outputs and adjusting feedback
    while (iCount != 0)
    {
      iCount  = find_string ( g_sOutputBuffer, ',', 1 );	
      sOutput = remove_string( g_sOutputBuffer, ',', 1 );
      sOutput = left_string( sOutput, (length_string( sOutput ) - 1) );
      if (sOutput == "")
        sOutput = g_sOutputBuffer;
      send_command dvTP, "'^TXT-',sOutput,',0,',itoa( iBut )";
      send_command dvTP, "'^BCF-',sOutput,',1,#0216CDFF'";
    }
    g_sOutputBuffer = "";
  }
}

  
data_event[vdvHDAnywhere]
{
  string:
  {
    char sJunk[255], 
		 sFBOutput[3], 
		 sFBInput[3], 
		 sValue[20];
		 
    integer iOutputNum;
    if (find_string( data.text, 'SW ', 1 ))
    {
      while (length_string( data.text ) > 3)
      {
        sJunk = remove_string( data.text, 'SW ', 1 );
        sJunk = remove_string( data.text, ';', 1 );
        sFBOutput = remove_string( sJunk, '=', 1 );
        sFBOutput = left_string( sFBOutput, length_string( sFBOutput ) - 1 );
        sFBInput = sJunk;
        sFBInput = left_string( sFBInput, length_string( sFBInput ) - 1 );
        if (sFBInput != "" || sFBOutput != "")
		{
		  iOutputNum = atoi( sFBOutput );
		  if (iOutputNum >= 1 && iOutputNum <= 8)
		  send_command dvTP, "'^TXT-', itoa( cOUTPUT_NUMBERS[ioutputNum] ), ',0,', sFBInput";
		}
      }
    }
    else if (find_string( data.text, 'Version = ', 1 ))
    {
      sJunk = remove_string( data.text, 'Version = ', 1 );
      sValue = data.text;
      send_command dvTP, "'^TXT-',itoa( FB_VERSION ),',0,',sValue";      
    }
    else if (find_string( data.text, 'Debug = ', 1 ))
    {
      sJunk = remove_string( data.text, 'Version = ', 1 );
      sValue = data.text;
      send_command 0:0:0, "'debug = ', sValue";      
    } 
  }
}
define_program



